<template>
    <div class="flex flex-col">

        <div class="container flex flex-col items-center mx-auto mt-10 px-5">
            <div class="flex w-full justify-end">
                <button @click="newEntry" type="button" class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800"> + New To Do</button>
            </div>

            <table-list
                    :enable-select="false"
                    :columns="todoTable.columns"
                    :actions="todoTable.actions"
                    :data="todos"
                    :pagination-links="pagination.links"
                    :pagination-data="pagination.data"
                    @paginationClick="getLink"
            />
        </div>

        <!--details-->
        <plain-modal :showing="showModalEdit">
            <div class="flex justify-between items-center px-3 pt-3 rounded-t-lg border-b-2 shadow-sm">
                <h3 class="mb-4 text-xl font-medium text-gray-900 dark:text-white">{{form.id !== null ? 'Update ': 'New '}}To-do Details Entry</h3>
                <button @click="showModalEdit =! showModalEdit" type="button" class=" bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-gray-800 dark:hover:text-white">
                    <svg class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd"></path></svg>
                </button>
            </div>

            <div class="flex bg-red-100 rounded-lg py-4 px-6 text-base text-red-700 mx-8 mt-4" role="alert" v-show="showAlert">
                {{alertMessage}}
            </div>
            <form class="space-y-6 p-8" action="#">
                <div>
                    <label for="title" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Title</label>
                    <input v-model="form.title" type="text" name="title" id="title" class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-600 dark:border-gray-500 dark:placeholder-gray-400 dark:text-white" placeholder="title" required>
                </div>
                <div>
                    <label for="description" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Description</label>
                    <textarea v-model="form.description" name="password" rows="4" id="description" placeholder="Description" class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-600 dark:border-gray-500 dark:placeholder-gray-400 dark:text-white" required> </textarea>
                </div>

                <div>
                    <label for="schedule" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Date</label>
                    <date-picker v-model="form.schedule" id="schedule" valueType="format" input-class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-600 dark:border-gray-500 dark:placeholder-gray-400 dark:text-white"></date-picker>
                </div>

                <div>
                    <label for="status" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Status</label>
                    <select v-model="form.status" name="title" id="status" class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-600 dark:border-gray-500 dark:placeholder-gray-400 dark:text-white">
                        <option selected>Choose a status</option>
                        <option value="0">Pending</option>
                        <option value="1">Done</option>
                    </select>
                </div>
                <button @click="saveTodo" type="button" class="w-full text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">Save</button>
            </form>
        </plain-modal>

        <plain-modal :showing="showModalDelete" >
            <!--body-->
            <div class="text-center p-5 flex-auto justify-center">
                <svg xmlns="http://www.w3.org/2000/svg" class="w-4 h-4 -m-1 flex items-center text-red-500 mx-auto"
                     fill="none" viewBox="0 0 24 24" stroke="currentColor">
                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
                          d="M13 16h-1v-4h-1m1-4h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"></path>
                </svg>
                <svg xmlns="http://www.w3.org/2000/svg" class="w-16 h-16 flex items-center text-red-500 mx-auto"
                     viewBox="0 0 20 20" fill="currentColor">
                    <path fill-rule="evenodd"
                          d="M9 2a1 1 0 00-.894.553L7.382 4H4a1 1 0 000 2v10a2 2 0 002 2h8a2 2 0 002-2V6a1 1 0 100-2h-3.382l-.724-1.447A1 1 0 0011 2H9zM7 8a1 1 0 012 0v6a1 1 0 11-2 0V8zm5-1a1 1 0 00-1 1v6a1 1 0 102 0V8a1 1 0 00-1-1z"
                          clip-rule="evenodd"/>
                </svg>
                <h2 class="text-xl font-bold py-4 ">Are you sure?</h2>
                <p class="text-sm text-gray-500 px-8">Do you really want to remove this item?</p>
            </div>
            <!--footer-->
            <div class="p-3  mt-2 text-center space-x-4 md:block">
                <button @click="showModalDelete = !showModalDelete" class="mb-2 md:mb-0 bg-white px-5 py-2 text-sm shadow-sm font-medium tracking-wider border text-gray-600 rounded-full hover:shadow-lg hover:bg-gray-100">
                    Cancel
                </button>
                <button @click="removeTodo" class="mb-2 md:mb-0 bg-red-500 border border-red-500 px-5 py-2 text-sm shadow-sm font-medium tracking-wider text-white rounded-full hover:shadow-lg hover:bg-red-600">
                    Delete
                </button>
            </div>
        </plain-modal>

    </div>
</template>

<script>
    import TableList from "../custom/TableList";
    import PlainModal from "../custom/PlainModal";
    import DatePicker from 'vue2-datepicker';
    import 'vue2-datepicker/index.css';
    export default {
        name: "Home",
        components: {PlainModal, TableList, DatePicker},
        data(){
            return {
                todoTable:{
                    columns:[
                        {name:'id', text:'ID'},
                        {name:'title', text:'Title'},
                        {name:'description', text:'Description'},
                        {name:'schedule', text:'Date'},
                        {
                            text: 'Status',
                            render: (row, index) =>{
                                if(row.status){
                                    return `<span class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-green-100 text-green-800">Done</span>`
                                }else{
                                    return `<span class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-red-100 text-red-800">Pending</span>`
                                }

                            }
                        }
                    ],
                    actions:[
                        {
                            text: 'Edit',
                            action: async (row,index) =>{
                                this.showEdit(row)
                            }
                        },
                        {
                            text: 'Delete',
                            action: async (row,index) =>{
                                this.showDelete(row)
                            }
                        },
                    ],

                },
                pagination:{
                    data:{},
                    links:[]
                },
                todos:[],
                showModalEdit:false,
                showModalDelete:false,
                showAlert:false,
                alertMessage:'',
                form:{
                    id:null,
                    title:null,
                    description:null,
                    schedule:null,
                    status:false
                }
            }
        },
        async mounted(){
            await this.getTodos();
        },
        methods:{
            async getTodos(url = ''){
                await axios.get(url === '' || url === null ? '/api/todos': url).then(response =>{
                    if(response.data.success){
                        this.todos = response.data.result.data;
                        this.pagination.data = response.data.result;
                        this.pagination.links = response.data.result.links;
                    }else{
                        console.log(response.data.message);
                    }
                }).catch(error =>{
                    console.log(error)
                })
            },
            newEntry(){
                this.form.id = null;
                this.form.title = null;
                this.form.description = null;
                this.form.schedule = null;
                this.form.status = 0;
                this.showModalEdit = true;
            },
            async showEdit(row){
                this.showModalEdit = true;
                this.form.id = row.id;
                this.form.title = row.title;
                this.form.description = row.description;
                this.form.schedule = row.schedule;
                this.form.status = row.status;
            },
            async saveTodo(){
                // debugger;
                await axios.post('/api/save',this.form).then(response =>{
                    if(response.data.success){
                        this.getTodos();
                        this.showModalEdit = false;
                        this.$toasted.show(response.data.message);
                    }else{
                        this.showAlert = true;
                        this.alertMessage = response.data.message;
                    }

                })
            },
            showDelete(row){
                this.showModalDelete = true;
                this.form.id = row.id
            },
            async removeTodo(){
                await axios.post('/api/remove',{id:this.form.id}).then(async response =>{
                    if (response.data.success){
                       await this.getTodos();
                       this.showModalDelete = false;
                        this.$toasted.show(response.data.message);
                    }else
                        console.log(response.data.message);

                }).catch(e => {
                    console.log(e);
                })
            },
            getLink(val){
                this.getTodos(val);
            }
        }
    }
</script>

<style scoped>
.mx-datepicker{
    width: 100% !important;
}
</style>